=== SimTKcommon/staticTarget/CMakeLists.txt ===
## This whole directory exists just so I could define this extra 
## preprocessor values.

ADD_DEFINITIONS(-DSimTK_SimTKCOMMON_BUILDING_STATIC_LIBRARY 
		        -DSimTK_USE_STATIC_LIBRARIES)

IF(BUILD_UNVERSIONED_LIBRARIES)
    ADD_LIBRARY(${STATIC_TARGET} STATIC 
		${SOURCE_FILES} ${SOURCE_INCLUDE_FILES} 
		${API_ABS_INCLUDE_FILES})

	ADD_DEPENDENCIES(${STATIC_TARGET} PlatformFiles)

	TARGET_LINK_LIBRARIES(${STATIC_TARGET} ${MATH_LIBS_TO_USE})

	SET_TARGET_PROPERTIES(${STATIC_TARGET} PROPERTIES
	    PROJECT_LABEL "Code - ${STATIC_TARGET}")

	INSTALL(TARGETS ${STATIC_TARGET}  
        PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ GROUP_WRITE WORLD_READ 
		ARCHIVE DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR} 
		LIBRARY DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR} 
		RUNTIME DESTINATION ${CMAKE_INSTALL_FULL_BINDIR} )
ENDIF(BUILD_UNVERSIONED_LIBRARIES)

IF(BUILD_VERSIONED_LIBRARIES)
    ADD_LIBRARY(${STATIC_TARGET_VN} STATIC 
		${SOURCE_FILES} ${SOURCE_INCLUDE_FILES} 
		${API_ABS_INCLUDE_FILES})

	ADD_DEPENDENCIES(${STATIC_TARGET_VN} PlatformFiles)

	TARGET_LINK_LIBRARIES(${STATIC_TARGET_VN} ${MATH_LIBS_TO_USE_VN})

	SET_TARGET_PROPERTIES(${STATIC_TARGET_VN} PROPERTIES
	    PROJECT_LABEL "Code - ${STATIC_TARGET_VN}")

	INSTALL(TARGETS ${STATIC_TARGET_VN}  
        PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ GROUP_WRITE WORLD_READ 
		ARCHIVE DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR} 
		LIBRARY DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR} 
		RUNTIME DESTINATION ${CMAKE_INSTALL_FULL_BINDIR} )
ENDIF(BUILD_VERSIONED_LIBRARIES)
