=== debian/changelog ===
simbody (3.4.1+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #728723)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 04 Apr 2014 22:20:51 +0000
